#$Id: main.mk,v 1.4 2007/12/12 19:09:30 rbudden Exp $
#
# Makefile for Cogster
######################


# Define our suffixes
.SUFFIXES: .class .java

TEST 	= suite

all: ${CLASSES}
	@for i in ${SUBDIRS};					\
	do							\
		echo "===>";					\
		cd $$i && make && cd ..;			\
		echo "<===";					\
	done;

# Create our suffix relation between .java/.class files
.java.class:
	${JAVAC} -classpath ${CLASSPATH} ${JFLAGS} $<

# run the current directory test suite
test: ${CLASSES} ${TEST}.class
	${JAVA} -cp ${CLASSPATH}:. ${TEST}

# run all test suites contained in this heirarchy
suite:
	@for i in ${SUBDIRS};					\
	do							\
		cd $$i;						\
		if [ -e ${TEST}.java ]; then			\
			echo "===> $$i";			\
			make test;				\
			echo "<===";				\
		fi;						\
		cd ..;						\
	done;

clean:
	@for i in ${SUBDIRS};					\
	do							\
		echo "===>";					\
		cd $$i && make clean && cd ..;			\
		echo "<===";					\
	done;

	@rm -f ${CLASSES};
	@rm -f ${TEST}.class;
